import datetime,os
import log,skel,tcgcore,variables

def tradegen(colour=False):
    if not os.path.isdir("build/trade"):
        os.mkdir("build/trade")
    if colour:
        if not os.path.isdir("build/trade/" + colour):
            os.mkdir("build/trade/" + colour)
        thefile = "build/trade/" + colour + "/index.html"
    else:
        thefile = "build/trade/index.html"
    if os.path.exists(thefile):
        os.remove(thefile)
    skel.headerwrite(thefile,"trade")
    content = open(thefile,"a")
    content.write("<h1>available for trade</h1>\n")
    content.write(tcgcore.filterwrite("trade",colour,True))
    content.write("<p>")
    if len(variables.tradestatement) > 0:
        content.write(variables.tradestatement + " ")
    content.write("Trade cards <a href=\"" + variables.tradepost + "\">here</a></p>\n<p>")
    previouscard = ""
    for card in tcgcore.ownedcards():
        if card[0:4] != "sig_":
            if card == previouscard:
                if colour:
                    if tcgcore.cardtype(card) == colour:
                        content.write(tcgcore.printcard(card))
                else:
                    content.write(tcgcore.printcard(card))
            else:
                if not tcgcore.deckmastered(card[:-2]):
                    if not tcgcore.collecting(card[:-2]):
                        if colour:
                            if tcgcore.cardtype(card) == colour:
                                content.write(tcgcore.printcard(card))
                        else:
                            content.write(tcgcore.printcard(card))
        previouscard = card
    siglist = []
    for card in tcgcore.ownedcards():
        if card == "sig_" + variables.name.lower():
            siglist.append(card)
    if variables.keepsig == True:
        siglist.remove(siglist[0])
    if colour:
        if colour == "sig":
            for sig in siglist:
                content.write(tcgcore.printcard(sig))
    else:
        for sig in siglist:
            content.write(tcgcore.printcard(sig))
    content.write("</p>\n")
    content.close()
    skel.footerwrite(thefile)

def tradeall():
    tradegen()
    for type in tcgcore.typelist:
        tradegen(type)
    tradegen("sig")
        
if __name__ == "__main__":
    tradeall()
